version: '3.5'
services: # firstly create dbs
  auth-db:
    container_name: auth-db
    image: postgres
    networks:
      - backend
    ports:
      - "5432:5432"
    environment:
      POSTGRES_PASSWORD: postgres

  order-db:
    container_name: order-db
    image: postgres
    networks:
      - backend
    ports:
      - "5433:5432"
    environment:
      POSTGRES_PASSWORD: postgres

  parcel-db:
    container_name: parcel-db
    image: postgres
    networks:
      - backend
    ports:
      - "5434:5432"
    environment:
      POSTGRES_PASSWORD: postgres

  rabbit-mq:
    container_name: rabbitmq
    image: rabbitmq:3-management
    networks:
      - backend
    ports:
      - "5672:5672"
      - "15672:15672"

  api-gateway:
    container_name: api-gateway
    image: api-gateway:1.0.0
    build:
      context: ./api-gateway
      dockerfile: Dockerfile
    networks:
      - backend
    ports:
      - "8080:8080"
    restart: unless-stopped
    environment:
      MS-AUTH-URL: http://auth-ms:8081
      MS-ORDER-URL: http://order-ms:8082
      MS-DISTRIBUTION-URL: http://parcel-ms:8083
    depends_on:
      - auth-ms
      - order-ms
      - parcel-ms

  auth-ms:
    container_name: auth-ms
    image: auth-ms:1.0.0
    build:
      context: ./auth-ms
      dockerfile: Dockerfile
    networks:
      - backend
    ports:
      - "8081:8081"
    restart: unless-stopped
    environment:
      AUTH_DATASOURCE_URL: jdbc:postgresql://auth-db:5432/postgres
    depends_on:
      - auth-db

  order-ms:
    container_name: order-ms
    image: order-ms.1.0.0
    build:
      context: ./order-ms
      dockerfile: Dockerfile
    networks:
      - backend
    ports:
      - "8082:8082"
    restart: unless-stopped
    environment:
      ORDER_DATASOURCE_URL: jdbc:postgresql://order-db:5433/postgres
      AUTH-MS-CHECK-TOKEN: http://auth-ms:8081/api/auth/check/jwtToken
      RABBIT_HOST: rabbit-mq
      RABBIT_PORT: 5672
    depends_on:
      - order-db
      - auth-ms
      - rabbit-mq

  parcel-ms:
    container_name: parcel-ms
    image: parcel-ms:1.0.0
    build:
      context: ./parcel-ms
      dockerfile: Dockerfile
    networks:
      - backend
    ports:
      - "8083:8083"
    environment:
      AUTH-MS-CHECK-TOKEN: http://auth-ms:8081/api/auth/check/jwtToken
      PARCEL_DATASOURCE_URL: jdbc:postgresql://parcel-db:5434/postgres
      RABBIT_HOST: rabbit-mq
      RABBIT_PORT: 5672
    depends_on:
      - parcel-db
      - auth-ms
      - rabbit-mq

networks:
  backend:
    name: backend
    driver: bridge







